#include <Constants.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <GUIListView.au3>

#include <FASM.au3>
#include <Array.au3>


Global $fasm=0
Local $funcs[1]=[0]


Func _($code)
	FasmAdd($fasm,$code)
EndFunc

Func _ASMinit()
	$fasm=FasmInit()
	OnAutoItExitRegister("_ASMexit")
EndFunc

Func _ASMcreateFunc($func)
	If $func="" Or $fasm=0 Then Return SetError(1,0,0)
	FasmReset($fasm)
	_("use32")
	_("org "&FasmGetBasePtr($fasm))
	Call($func)
	If @error Then Return SetError(1,1,0)
	Local $bin=FasmGetBinary($fasm)
	If @error Then
		Local $Error = FasmGetLastError()
        MsgBox(0, "FASM-ERROR in function " & $func & "()", "Error Code: " & $Error[0] & _
                @CRLF & "Error Message: " & $Error[1] & @CRLF & "Error Line: " & $Error[2] & @CRLF & _
				"corrupt Code: " & $Error[3])
		Return SetError(1,2,0)
	EndIf
	Local $struct=DllStructCreate("byte["&(StringLen($bin)/2-1)&"]")
	FasmReset($fasm)
	_("use32")
	_("org "&DllStructGetPtr($struct))
	Call($func)
	$bin=FasmGetBinary($fasm)
	DllStructSetData($struct,1,$bin)
	_ArrayAdd($funcs,$struct)
	$funcs[0]+=1
	Return DllStructGetPtr($struct)
EndFunc


Func _ASMexit()
	FasmExit($fasm)
	$fasm=0
EndFunc





;Andys ASM debugger
;debug-Fenster


Dim $_DBG_LABEL[170]

Global $hwnd_weiterbutton,$_DBG_closebutton
Global $_DBG_firstcall = True, $_DBG_buttonID

Global $_DBG_GUI = GUICreate("AssembleIt Debug-Info 1.0", 670, 550, 10, 10, 0, $WS_EX_DLGMODALFRAME)
global $_DBG_winpos = WinGetPos($_DBG_GUI)
global $_DBG_Window_posold_x = $_DBG_winpos[0]                        ;fensterposition merken
global $_DBG_Window_posold_y = $_DBG_winpos[1] + $_DBG_winpos[3]

;$WM_MOVING = 0x0216
Global $_DBG_BUTTONSGUI = -1
GUIRegisterMsg(0x0216, "_DBG_WM_MOVING") ; $WM_MOVING
GUIRegisterMsg(0x0232, "_DBG_WM_MOVING") ; $WM_EXITSIZEMOVE
GUIRegisterMsg($WM_MOVE, "_DBG_WM_MOVING")

;~ GUIRegisterMsg($WM_MOVING, "_DBG_WM_MOVING")
;~ GUIRegisterMsg($WM_SIZE, "_DBG_WM_SIZE")
;GUIRegisterMsg($WM_COMMAND, "_DBG_WM_COMMAND")


$_DBG_LABEL[18] = GUICtrlCreateLabel("FPU-Register showed as DOUBLE!", 10, 175, 290, 16)
GUICtrlSetFont(-1,-1, -1, 4)
;GUICtrlSetResizing ( -1, 32+ 2 )
$_DBG_LABEL[17] = GUICtrlCreateLabel("EFlags", 580, 16, 102, 16)
GUICtrlSetFont(-1, -1, -1, 4)

$_DBG_LABEL[38] = GUICtrlCreateLabel("CF =", 580, 32 + 16 * 0, 30, 16);CF
$_DBG_LABEL[59] = GUICtrlCreateLabel("DF =", 580, 32 + 16 * 1, 30, 16)
$_DBG_LABEL[39] = GUICtrlCreateLabel("PF =", 580, 32 + 16 * 2, 30, 16)
$_DBG_LABEL[68] = GUICtrlCreateLabel("OF =", 580, 32 + 16 * 3, 30, 16)
$_DBG_LABEL[48] = GUICtrlCreateLabel("AF =", 580, 32 + 16 * 4, 30, 16)
$_DBG_LABEL[49] = GUICtrlCreateLabel("ZF =", 580, 32 + 16 * 6, 30, 16)
$_DBG_LABEL[58] = GUICtrlCreateLabel("SF =", 580, 32 + 16 * 7, 30, 16)


For $i = 0 To 7
    $_DBG_LABEL[10 + $i] = GUICtrlCreateLabel("ST" & $i & " = ", 10 + Mod($i, 2) * 180, 195 + 16 * Int($i / 2), 30, 16)
    $_DBG_LABEL[80 + $i] = GUICtrlCreateLabel("", 50 + Mod($i, 2) * 180, 195 + 16 * Int($i / 2), 100, 16)
    $_DBG_LABEL[30 + $i] = GUICtrlCreateLabel("XMM" & $i & " = ", 10, 400 + 15 * $i, 40, 16);XMM0-XMM7
    $_DBG_LABEL[90 + $i] = GUICtrlCreateLabel("", 60, 400 + 15 * $i, 300, 16);XMM
    $_DBG_LABEL[40 + $i] = GUICtrlCreateLabel("", 60, 32 + 16 * $i, 400, 16);hex
    $_DBG_LABEL[50 + $i] = GUICtrlCreateLabel("", 150, 32 + 16 * $i, 400, 16);int
    $_DBG_LABEL[60 + $i] = GUICtrlCreateLabel("", 230, 32 + 16 * $i, 300, 16);float
    $_DBG_LABEL[70 + $i] = GUICtrlCreateLabel("", 320, 32 + 16 * $i, 240, 16);bin
    $_DBG_LABEL[100 + $i] = GUICtrlCreateLabel("", 610, 32 + 16 * $i, 40, 16) ;eflags
    $_DBG_LABEL[110 + $i] = GUICtrlCreateLabel("", 280, 400 + 15 * $i, 250, 16);XMM-2xdouble
    $_DBG_LABEL[120 + $i] = GUICtrlCreateLabel("", 440, 400 + 15 * $i, 250, 16);XMM-4xfloat
Next
GUICtrlSetPos($_DBG_LABEL[105], 590, 32 + 16 * 5, 1, 1)        ;platz machen fr ungenutztes label

$_DBG_LABEL[20] = GUICtrlCreateLabel("FPU-Flags", 10, 270, 55, 16)
GUICtrlSetFont(-1, -1, -1, 4)
$_DBG_LABEL[21] = GUICtrlCreateLabel("CO=            C1=            C2=", 520, 200, 135, 20)

$_DBG_LABEL[25] = GUICtrlCreateLabel("Stack", 370, 175, 130, 20)
GUICtrlSetFont(-1, -1, -1, 4)
$_DBG_LABEL[26] = GUICtrlCreateLabel("HEX", 450, 175, 130, 20)
GUICtrlSetFont(-1, -1, -1, 4)
$_DBG_LABEL[27] = GUICtrlCreateLabel("INT", 550, 175, 130, 20)
GUICtrlSetFont(-1, -1, -1, 4)
For $i = 40 To 0 Step -4
    $_DBG_LABEL[129 + $i / 4] = GUICtrlCreateLabel(StringFormat("[esp %+02.2d]", 40 - $i), 370, 195 + 16 * $i / 4, 50, 16);129-140
    $_DBG_LABEL[141 + $i / 4] = GUICtrlCreateLabel("", 450, 195 + 16 * $i / 4, 100, 16);141-152
    $_DBG_LABEL[155 + $i / 4] = GUICtrlCreateLabel("", 550, 195 + 16 * $i / 4, 100, 16);155-161
Next

$_DBG_LABEL[108] = GUICtrlCreateLabel("SSE-Register            HEX", 10, 375, 150, 20)
GUICtrlSetFont(-1, -1, -1, 4)
$_DBG_LABEL[109] = GUICtrlCreateLabel("2x Double", 280, 375, 100, 20)
GUICtrlSetFont(-1, -1, -1, 4)
$_DBG_LABEL[118] = GUICtrlCreateLabel("4x Float", 450, 375, 100, 20)
GUICtrlSetFont(-1, -1, -1,4)


;GUIRegisterMsg($WM_COMMAND, "MyWM_COMMAND")

Global $listviewitem_reg32[8]
Global $reg_32[8] = ["EAX", "EBX", "ECX", "EDX", "ESI", "EDI", "ESP", "EBP"]

global $Listview_reg32 = GUICtrlCreateListView("REG32|HEX|INT|FLOAT|BIN [BIT31....Bit0]", 10, 2, 560, 172, BitOR($GUI_SS_DEFAULT_LISTVIEW, $LVS_NOSORTHEADER));,$GUI_BKCOLOR_LV_ALTERNATE )
GUICtrlSetFont(-1, 8.5, -1,-1)
GUICtrlSetBkColor($Listview_reg32, 0xF0f0f0)                   ; Grau
GUICtrlSetBkColor($Listview_reg32, $GUI_BKCOLOR_LV_ALTERNATE)

_GUICtrlListView_BeginUpdate($Listview_reg32)
For $i = 0 To 7
    $listviewitem_reg32[$i] = GUICtrlCreateListViewItem($reg_32[$i] & "|0xDDDDDDDD|88888888888|9.99999999E999|00000000 00000000 00000000 00000000 ", $Listview_reg32)
    GUICtrlSetBkColor($listviewitem_reg32[$i], 0xFFFFFF)       ; weiss
Next
For $i = 0 To 4
    _GUICtrlListView_SetColumnWidth($Listview_reg32, $i, $LVSCW_AUTOSIZE_USEHEADER);$LVSCW_AUTOSIZE)
Next
_GUICtrlListView_EndUpdate($Listview_reg32)


;thx progandy fr den "button" !
Global Const $tagDLGTEMPLATE = "align 2                        ;DWORD style; DWORD dwExtendedStyle; WORD  cdit; short x; short y; short cx; short cy;"
Global Const $tagDLGITEMTEMPLATE = "align 2                    ;DWORD style; DWORD dwExtendedStyle; short x; short y; short cx; short cy; WORD  id;"



Global $_DBG_noshowflag=0
Global $dlgproc = DllCallbackRegister("_DlgProc", "bool", "hwnd;uint;wparam;lparam")
Global $_DBG_ = DllCallbackRegister("_DBG_MSGBOX", "dword", "dword;dword;dword;dword;dword;dword;dword;dword;dword")
;speicher reservieren fr datenbereich
Global $ptr_dbgmem = Number(_MemGlobalAlloc(600, 0))           ;512 byte + 8 byte weil nur 8byte-align

local $mod = Mod($ptr_dbgmem, 16)                                    ;bentigt wird fr SSE-Register abe 16-byte-align
If $mod <> 0 Then
    $ptr_dbgmem += (16 - $mod)                                 ;16 byte align
EndIf


Global $_dbg_string[100], $_DBG_nr = 0, $_DBG_command[2]
Global $struct_FXSAVE = DllStructCreate("byte[512]", $ptr_dbgmem);platz fr Daten aus FXSAVE
Global $struct_STACK = DllStructCreate("dword[11]", $ptr_dbgmem + 520);platz fr Daten aus STACK [esp-20] bis [esp+20]
Global $ptr_STACK = DllStructGetPtr($struct_STACK)
;http://siyobik.info/index.php?module=x86&id=128
;ob ich diese flags noch einbaue, weiss ich nicht
local $struct = DllStructCreate("" & _
        "word FCW;" & _                                        ;FPU control word  0+1
        "word FSW;" & _                                        ;FPU statusword    2+3
        "byte FTW;" & _                                        ;FPU ag word    4
        "byte;" & _                                            ;reserved    5
        "word FOP;" & _                                        ;FPU opcode    6+7
        "dword FIP;" & _                                       ;FPU instruction pointer 8-11
        "word CS;" & _                                         ;        12-13
        "word ;" & _                                           ;reserved    14-15
        "dword FDP;" & _                                       ; 16-19
        "word DS;" & _                                         ;    20+21
        "word ;" & _                                           ;reserved    22-23
        "dword MXCSR;" & _                                     ;MXCSR    24-27
        "dword MXCSR_MASK;" & _                                ;MXCSR_MASK    28-31
        "byte[10] ST0;")                                       ;ST0    32-41


global $struct_double = DllStructCreate("double[8]")                  ;platz fr 8 doubles der FPU register st0-st7
global $struct_128SSE = DllStructCreate("byte[128]", Ptr($ptr_dbgmem + 160));platz fr 16 byte SSE
global $struct_EFLAGS = DllStructCreate("dword EFLAGS", Ptr($ptr_dbgmem + 512));platz 32 bit eflags
Global $ptr_SSE = DllStructGetPtr($struct_128SSE)              ;pointer
Global $ptr_EFLAGS = DllStructGetPtr($struct_EFLAGS)
global $struct_SSE64x2int = DllStructCreate("uint64[16]", $ptr_SSE)   ;platz fr 2x 64byte SSE
global $struct_SSE32x4int = DllStructCreate("uint[32]", $ptr_SSE)     ;platz fr 4x 32byte SSE
global $struct_SSE16x8int = DllStructCreate("word[64]", $ptr_SSE)     ;platz fr 8x 16byte SSE
global $struct_SSE64x2dbl = DllStructCreate("double[16]", $ptr_SSE)   ;platz fr 2x 64byte DOUBLE SSE
global $struct_SSE32x4flt = DllStructCreate("float[32]", $ptr_SSE)    ;platz fr 4x 32byte FLOAT SSE



;debug-funktion, aus dem asmcode per call an die callback-adresse aufgerufen
Func _DBG_MSGBOX($anz, $edi, $esi, $ebp, $esp, $ebx, $edx, $ecx, $eax);aus asm bergebene register
    If $_DBG_noshowflag = 1 Then Return 0
    GUISetState(@SW_SHOW, $_DBG_GUI)
    _WinAPI_UpdateWindow($_DBG_GUI)
    ;_DBG_WM_SIZE($_DBG_GUI,0,0,0)


    Dim $reg[8] = [$eax, $ebx, $ecx, $edx, $esi, $edi, $esp, $ebp]
    _GUICtrlListView_BeginUpdate($Listview_reg32)

    For $i = 0 To 7 ;fenster mit Werten fllen
        GUICtrlSetData($listviewitem_reg32[$i], "|" & Ptr($reg[$i]) & "|" & _
                String($reg[$i]) & "|" & _
                StringFormat(" %2.6G", int2float($reg[$i])) & "|" & int2bin($reg[$i])) ;hex
        GUICtrlSetData($_DBG_LABEL[$i + 80], DllStructGetData($struct_double, 1, $i + 1));FPU st0-st7
		;SSE
		$struct_temp = DllStructCreate("byte[16]", $ptr_SSE + 16 * $i)
		$struct = DllStructCreate("byte[16]")
		for $z=1 to 16
		  dllstructsetdata($struct,1,dllstructgetdata($struct_temp,1,17-$z),$z)
		next

        GUICtrlSetData($_DBG_LABEL[$i + 90], DllStructGetData($struct, 1))



        GUICtrlSetData($_DBG_LABEL[$i + 100], BitAND(2 ^ $i, DllStructGetData($struct_EFLAGS, 1)) / (2 ^ $i));eflags

        $struct = DllStructCreate("double[2]", $ptr_SSE + 16 * $i); 2x 64byte DOUBLE SSE
        GUICtrlSetData($_DBG_LABEL[$i + 110], StringFormat("%6s    %6s", DllStructGetData($struct, 1, 2), DllStructGetData($struct, 1, 1)))
        $struct = DllStructCreate("float[4]", $ptr_SSE + 16 * $i); 4x 32byte FLOAT SSE
        GUICtrlSetData($_DBG_LABEL[$i + 120], StringFormat("%10.5f  %10.5f  %10.5f  %10.5f", DllStructGetData($struct, 1, 4), DllStructGetData($struct, 1, 3), DllStructGetData($struct, 1, 2), DllStructGetData($struct, 1, 1)))
    Next
    GUICtrlSetData($_DBG_LABEL[101], BitAND(2 ^ 10, DllStructGetData($struct_EFLAGS, 1)) / (2 ^ 10));eflags DF
    GUICtrlSetData($_DBG_LABEL[103], BitAND(2 ^ 11, DllStructGetData($struct_EFLAGS, 1)) / (2 ^ 11));eflags OF
    For $i = 0 To 10 ;stack
        GUICtrlSetData($_DBG_LABEL[141 + $i], Ptr(DllStructGetData($struct_STACK, 1, $i + 1)));stack hex
        GUICtrlSetData($_DBG_LABEL[155 + $i], Int(DllStructGetData($struct_STACK, 1, $i + 1)));stack int
    Next
    _GUICtrlListView_EndUpdate($Listview_reg32)

    If $anz = 0 Or Execute($_dbg_string[$anz]) Then
        Switch __GET_MSGBOX_BUTTON()
            Case 0, 1
            Case 2
                $_DBG_noshowflag = True
            Case 3
                DllCall("kernel32.dll", "none", "ExitProcess", "int", 0xDEADBEEF)
        EndSwitch
    EndIf
    Return 0
EndFunc   ;==>_DBG_MSGBOX
Func __GET_MSGBOX_BUTTON()
    Local Static $tDLG, $aOldPos[4] = [0, 0, -1, -1]
    local $pos_DBB_Window = WinGetPos($_DBG_GUI) ;Positionsdaten der GUI holen
    If $aOldPos[0] <> $pos_DBB_Window[0] Or $aOldPos[1] <> $pos_DBB_Window[1] Or $aOldPos[2] <> $pos_DBB_Window[2] Or $aOldPos[2] <> $pos_DBB_Window[2] Then
        $aOldPos = $pos_DBB_Window
        Local $x = Int($pos_DBB_Window[0] / 2)
        Local $y = Int(($pos_DBB_Window[1] + $pos_DBB_Window[3]) / 2)

        ;es folgen die Daten fr den "...NEXT"-Button, der muss ein modales Fenster sein, wer da eine andere Idee hat, bitte melden
        Local $w = Int($pos_DBB_Window[2] / 2) ;breite Button
        Local $h = 30 ;hhe Button
        local $bTitle = StringToBinary("Next....", 2) ;text Button
        local $bXY = BinaryMid(Binary($x), 1, 2) & BinaryMid(Binary($y), 1, 2);Buttondaten
        local $bWH = BinaryMid(Binary($w), 1, 2) & BinaryMid(Binary($h), 1, 2)
        local $bWhalfH = BinaryMid(Binary(Int($w / 2 - 15)), 1, 2) & BinaryMid(Binary($h), 1, 2)
        local $bDIALOG = Binary("0x00000090400000040300") & $bXY & $bWH & Binary("0x000000000000") & Binary("0x000000500000000000000000") & $bWhalfH & Binary("0x0100FFFF8000") & $bTitle & Binary("0x0000") & Binary("0x0000")
        ;                   |Style ||ExStyl||cdit|                         |Empty "Arrays"|              |Style ||ExStyl||x ||y |                         |id||BUTTON|                       |Chr0|           |irgend welche anderen Arrays
        $x = Mod(BinaryLen($bDIALOG), 4)
        If $x Then $bDIALOG &= BinaryMid(Binary("0x000000"), 1, $x)
        $bTitle = StringToBinary("End Debugging", 2) ;text Button
        $bDIALOG &= Binary("0x0000005000000000") & BinaryMid(Int($w / 2 - 15), 1, 2) & Binary("0x0000") & $bWhalfH & Binary("0x0200FFFF8000") & $bTitle & Binary("0x0000") & Binary("0x0000")

        $x = Mod(BinaryLen($bDIALOG), 4)
        If $x Then $bDIALOG &= BinaryMid(Binary("0x000000"), 1, $x)
        $bTitle = StringToBinary("Kill", 2) ;text Button
        $bDIALOG &= Binary("0x0000005000000000") & BinaryMid(Int($w - 30), 1, 2) & Binary("0x0000") & BinaryMid(30, 1, 2) & BinaryMid($h, 1, 2) & Binary("0x0300FFFF8000") & $bTitle & Binary("0x0000") & Binary("0x0000")

        $tDLG = DllStructCreate("byte[" & BinaryLen($bDIALOG) & "]")
        DllStructSetData($tDLG, 1, $bDIALOG) ;Button-Daten in struct schreiben
    EndIf
    Local $aRet = DllCall("user32.dll", "int", "DialogBoxIndirectParamW", "ptr", 0, "ptr", DllStructGetPtr($tDLG), "hwnd", 0, "ptr", DllCallbackGetPtr($dlgproc), "lparam", 0)
    If @error Then Return 0
    Return $aRet[0]
EndFunc   ;==>__GET_MSGBOX_BUTTON


;Alle Register, Flags, Stack usw werden in einen Speicherbereich geschrieben und von dort mit
;der Funktion _DBG_MSGBOX() ausgelesen
Func _ASMdbg($_DBG_command = "")                              ;Register

    _("push dword[esp+40]")                                    ;stack in memory
    _("pop dword[" & $ptr_STACK & "]")
    _("push dword[esp+36]")                                    ;stack in memory
    _("pop dword[" & $ptr_STACK + 4 & "]")
    _("push dword[esp+32]")                                    ;stack in memory
    _("pop dword[" & $ptr_STACK + 8 & "]")
    _("push dword[esp+28]")                                    ;stack in memory
    _("pop dword[" & $ptr_STACK + 12 & "]")
    _("push dword[esp+24]")                                    ;stack in memory
    _("pop dword[" & $ptr_STACK + 16 & "]")
    _("push dword[esp+20]")                                    ;stack in memory
    _("pop dword[" & $ptr_STACK + 20 & "]")
    _("push dword[esp+16]")                                    ;stack in memory
    _("pop dword[" & $ptr_STACK + 24 & "]")
    _("push dword[esp+12]")                                    ;stack in memory
    _("pop dword[" & $ptr_STACK + 28 & "]")
    _("push dword[esp+08]")                                    ;stack in memory
    _("pop dword[" & $ptr_STACK + 32 & "]")
    _("push dword[esp+04]")                                    ;stack in memory
    _("pop dword[" & $ptr_STACK + 36 & "]")
    _("push dword[esp+00]")                                    ;stack in memory
    _("pop dword[" & $ptr_STACK + 40 & "]")

    _("pushfd")                                                ;eflags sichern
    _("pop dword[" & Ptr($ptr_EFLAGS) & "]")                   ;eflags speichern in struct
    _("pushfd")                                                ;eflags sichern
    _("push eax")
    _("mov eax," & $ptr_dbgmem)                                ;alle FPU+SSE Registerinhalte und flags sichern
    _("FXSAVE [eax]")
    _("fstp qword[" & DllStructGetPtr($struct_double) & "]")   ;alle FPU-Register sichern
    _("fstp qword[" & DllStructGetPtr($struct_double) + 8 & "]")
    _("fstp qword[" & DllStructGetPtr($struct_double) + 16 & "]")
    _("fstp qword[" & DllStructGetPtr($struct_double) + 24 & "]")
    _("fstp qword[" & DllStructGetPtr($struct_double) + 32 & "]")
    _("fstp qword[" & DllStructGetPtr($struct_double) + 40 & "]")
    _("fstp qword[" & DllStructGetPtr($struct_double) + 48 & "]")
    _("fstp qword[" & DllStructGetPtr($struct_double) + 56 & "]")
    ;  _("fwait")
    _("pop eax")
    _("pushad")                                                ;alle Register sichern
    _("pushad")                                                ;auf den stack fr fr die msgbox
    If $_DBG_command <> "" Then                                ;falls kein Befehl bergeben wurde
        $_DBG_nr += 1
        $_dbg_string[$_DBG_nr] = $_DBG_command
        _("push " & Ptr($_DBG_nr))                             ;anzahl der
    Else
        _("push " & Ptr(0))
    EndIf
    _("call " & DllCallbackGetPtr($_DBG_))                     ;in autoit-callbackroutine springen
    _("mov eax," & $ptr_dbgmem)                                ;alle FPU+SSE registerinhalte und flags restore
    _("FXRSTOR [eax]")                                         ;restore alle FPU-Register
    ;  _("fwait")
    _("popad")                                                 ;alle register wieder zurcksetzen
    _("popfd")                                                 ;eflags setzen
EndFunc                                                        ;==>_asmdbg_

Func bin2ascii($bin_string)                                    ;string aus nullen und einsen in 8-bit-ascii text string umwandeln
    local $step = 8                                                  ;8-Bit ASCII Buchstaben
    local $ascii_string = ""                                         ;Rckgabestring
    For $f = 1 To StringLen($bin_string) Step $step            ;string von Vorne nach hinten 8-bitweise durchsuchen
        local $t = StringMid($bin_string, $f, $step)                 ; 8-Bit-Wort, ein ASCII-Buchstabe
        local $bin = 0                                               ;startwert fr
        For $i = 1 To $step                                    ;jedes Bit suchen
            If StringMid($t, $i, 1) = "1" Then $bin += (2 ^ ($step - $i)) ;wenn Bit=1 dann binrzahl=binrzahl+2^(8-Bitposition)
        Next
        $ascii_string &= Chr($bin)
    Next
    Return $ascii_string
EndFunc                                                        ;==>bin2ascii

Func int2bin($integer)                                         ;32Bit in binrstring darstellen
    local $bin_string = ""
    For $i = 31 To 0 Step -1                                   ;asciicode in bits
        If Mod($i + 1, 8) = 0 Then $bin_string &= " "
        If BitAND($integer, 2 ^ $i) Then
            $bin_string &= "1"
        Else
            $bin_string &= "0"
        EndIf

    Next
    Return $bin_string
EndFunc                                                        ;==>int2bin

Func int2float($integer)
    Local $struct = DllStructCreate("int")
    Local $struct2 = DllStructCreate("float", DllStructGetPtr($struct))
    DllStructSetData($struct, 1, $integer)
    local $ret = DllStructGetData($struct2, 1)
    $struct = 0
    $struct2 = 0
    Return $ret
EndFunc                                                        ;==>int2float

Func _DlgProc($hwnd, $uMsg, $wParam, $lParam)
    ;thx to progandy!
    If $uMsg = $WM_INITDIALOG Then
        $_DBG_BUTTONSGUI = $hwnd
    ElseIf $uMsg = $WM_CLOSE Then
        DllCall("user32.dll", "bool", "EndDialog", "hwnd", $hwnd, "int_ptr", 0)
        Return True
    ElseIf $uMsg = $WM_COMMAND Then
        DllCall("user32.dll", "bool", "EndDialog", "hwnd", $hwnd, "int_ptr", BitAND($wParam, 0xFFFF))
        Return True
    ElseIf $uMsg = $WM_DESTROY Then
        $_DBG_BUTTONSGUI = -1
    EndIf
    Return False
EndFunc   ;==>_DlgProc

Func _DBG_WM_MOVING($hWnd, $uMsg, $wParam, $lParam)
    If $hwnd = $_DBG_GUI And IsHWnd($_DBG_BUTTONSGUI) Then
        Local $pos = WinGetPos($hwnd)
        WinMove($_DBG_BUTTONSGUI, "", $pos[0], $pos[1]+$pos[3])
    EndIf
    Return $GUI_RUNDEFMSG
EndFunc


Func _DBG_WM_SIZE($hwnd, $message, $wParam, $lParam);fenstergrsse wird verndert
    Local $posgui = WinGetPos($_DBG_GUI)
    $_DBG_Window_posold_x = $posgui[0]                         ;fensterposition merken
    $_DBG_Window_posold_y = $posgui[1]
    ;WinMove($hwnd_weiterbutton, "", $pos[0], $pos[1] + $pos[3], 200, 60);buttonposition anpassen
    WinMove($hwnd_weiterbutton, "", $posgui[0], $posgui[1] + $posgui[3], $posgui[2], 60);fensterposition anpassen
    WinMove($_DBG_GUI, "", $posgui[0], $posgui[1], $posgui[2], $posgui[3]);fensterposition anpassen
    _WinAPI_SetWindowPos($_DBG_buttonID, 0, 0, 0, $posgui[2], 60, 0x0020);buttonpos im fenster resze
EndFunc                                                        ;==>_DBG_WM_SIZE








